import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime-corejs3/helpers/esm/inheritsLoose";
import _defineProperty from "@babel/runtime-corejs3/helpers/esm/defineProperty";
import Builder from './Builder';
import { builder } from './InstanceBuilder';

var ObjectBuilder = function (_Builder) {
  _inheritsLoose(ObjectBuilder, _Builder);

  function ObjectBuilder(contents, defaultValue) {
    var _this;

    if (contents === void 0) {
      contents = null;
    }

    if (defaultValue === void 0) {
      defaultValue = {};
    }

    _this = _Builder.call(this, 'object', defaultValue) || this;

    _defineProperty(_assertThisInitialized(_this), "contents", null);

    if ("production" !== process.env.NODE_ENV) {
      if (contents) {
        if (contents instanceof Builder) {
          _this.contents = contents;

          _this.addCheck(_this.checkContents, contents);
        } else {
          _this.invariant(false, 'A blueprint is required for object contents.');
        }
      }
    }

    return _this;
  }

  var _proto = ObjectBuilder.prototype;

  _proto.checkContents = function checkContents(path, value, contents) {
    var _this2 = this;

    if ("production" !== process.env.NODE_ENV) {
      var _context;

      _forEachInstanceProperty(_context = _Object$keys(value)).call(_context, function (key) {
        contents.runChecks(path + "." + key, value[key], _this2.currentStruct, _this2.options);
      });
    }
  };

  _proto.notEmpty = function notEmpty() {
    return this.addCheck(this.checkNotEmpty);
  };

  _proto.checkNotEmpty = function checkNotEmpty(path, value) {
    if ("production" !== process.env.NODE_ENV) {
      this.invariant(_Object$keys(value).length > 0, 'Object cannot be empty.', path);
    }
  };

  _proto.typeAlias = function typeAlias() {
    var contents = this.contents;

    var alias = _Builder.prototype.typeAlias.call(this);

    return contents ? alias + "<" + contents.typeAlias() + ">" : alias;
  };

  return ObjectBuilder;
}(Builder);

export { ObjectBuilder as default };
export function object(contents, defaultValue) {
  if (contents === void 0) {
    contents = null;
  }

  return new ObjectBuilder(contents, defaultValue);
}
export function blueprint(defaultValue) {
  return new ObjectBuilder(builder().notNullable(), defaultValue);
}