import _everyInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/every";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import isObject from './isObject';
export default function typeOf(value) {
  if (_Array$isArray(value)) {
    return _everyInstanceProperty(value).call(value, function (item) {
      return typeof item === typeof value[0];
    }) ? 'array' : 'union';
  }

  if (isObject(value)) {
    return value.constructor === Object ? 'object' : 'instance';
  }

  switch (typeof value) {
    case 'boolean':
    case 'function':
    case 'number':
    case 'string':
      return typeof value;

    default:
      return 'unknown';
  }
}