"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

require("core-js/modules/es.function.name");

require("core-js/modules/es.regexp.constructor");

require("core-js/modules/es.regexp.to-string");

exports.__esModule = true;
exports.instance = instance;
exports.builder = builder;
exports.regex = regex;
exports.date = date;
exports.default = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _Builder2 = _interopRequireDefault(require("./Builder"));

var _isObject = _interopRequireDefault(require("./isObject"));

var _instanceOf = _interopRequireDefault(require("./instanceOf"));

var InstanceBuilder = function (_Builder) {
  (0, _inheritsLoose2.default)(InstanceBuilder, _Builder);

  function InstanceBuilder(refClass, loose) {
    var _this;

    if (refClass === void 0) {
      refClass = null;
    }

    if (loose === void 0) {
      loose = false;
    }

    _this = _Builder.call(this, 'instance', null) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "loose", false);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "refClass", null);

    _this.nullable();

    if ("production" !== process.env.NODE_ENV) {
      if (refClass) {
        _this.invariant(typeof refClass === 'function', 'A class reference is required.');
      }

      _this.loose = loose;
      _this.refClass = refClass;

      _this.addCheck(_this.checkInstance, refClass);
    }

    return _this;
  }

  var _proto = InstanceBuilder.prototype;

  _proto.checkInstance = function checkInstance(path, value, refClass) {
    if ("production" !== process.env.NODE_ENV) {
      if (refClass) {
        this.invariant(typeof refClass === 'function' && (value instanceof refClass || this.loose && (0, _isObject.default)(value) && (0, _instanceOf.default)(value, refClass)), "Must be an instance of \"" + this.typeAlias() + "\".", path);
      } else {
        this.invariant((0, _isObject.default)(value) && value.constructor !== Object, 'Must be a class instance.', path);
      }
    }
  };

  _proto.typeAlias = function typeAlias() {
    var refClass = this.refClass;
    return refClass ? refClass.name || refClass.constructor.name : 'class';
  };

  return InstanceBuilder;
}(_Builder2.default);

exports.default = InstanceBuilder;

function instance(refClass, loose) {
  if (refClass === void 0) {
    refClass = null;
  }

  return new InstanceBuilder(refClass, loose);
}

function builder() {
  return instance(_Builder2.default);
}

function regex() {
  return instance(RegExp);
}

function date() {
  return instance(Date);
}