"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

exports.__esModule = true;
exports.object = object;
exports.blueprint = blueprint;
exports.default = void 0;

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));

var _Builder2 = _interopRequireDefault(require("./Builder"));

var _InstanceBuilder = require("./InstanceBuilder");

var ObjectBuilder = function (_Builder) {
  (0, _inheritsLoose2.default)(ObjectBuilder, _Builder);

  function ObjectBuilder(contents, defaultValue) {
    var _this;

    if (contents === void 0) {
      contents = null;
    }

    if (defaultValue === void 0) {
      defaultValue = {};
    }

    _this = _Builder.call(this, 'object', defaultValue) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "contents", null);

    if ("production" !== process.env.NODE_ENV) {
      if (contents) {
        if (contents instanceof _Builder2.default) {
          _this.contents = contents;

          _this.addCheck(_this.checkContents, contents);
        } else {
          _this.invariant(false, 'A blueprint is required for object contents.');
        }
      }
    }

    return _this;
  }

  var _proto = ObjectBuilder.prototype;

  _proto.checkContents = function checkContents(path, value, contents) {
    var _this2 = this;

    if ("production" !== process.env.NODE_ENV) {
      var _context;

      (0, _forEach.default)(_context = (0, _keys.default)(value)).call(_context, function (key) {
        contents.runChecks(path + "." + key, value[key], _this2.currentStruct, _this2.options);
      });
    }
  };

  _proto.notEmpty = function notEmpty() {
    return this.addCheck(this.checkNotEmpty);
  };

  _proto.checkNotEmpty = function checkNotEmpty(path, value) {
    if ("production" !== process.env.NODE_ENV) {
      this.invariant((0, _keys.default)(value).length > 0, 'Object cannot be empty.', path);
    }
  };

  _proto.typeAlias = function typeAlias() {
    var contents = this.contents;

    var alias = _Builder.prototype.typeAlias.call(this);

    return contents ? alias + "<" + contents.typeAlias() + ">" : alias;
  };

  return ObjectBuilder;
}(_Builder2.default);

exports.default = ObjectBuilder;

function object(contents, defaultValue) {
  if (contents === void 0) {
    contents = null;
  }

  return new ObjectBuilder(contents, defaultValue);
}

function blueprint(defaultValue) {
  return new ObjectBuilder((0, _InstanceBuilder.builder)().notNullable(), defaultValue);
}