import { Constructor } from './InstanceBuilder';
/**
 * Native `instanceof` checks are problematic, as cross realm checks fail.
 * They will also fail when comparing against source and built files.
 * So emulate an `instanceof` check by comparing constructor names.
 */
export default function instanceOf<T = unknown>(object: unknown, contract: Constructor<T> | Function): object is T;
