"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

require("core-js/modules/es.array.join");

require("core-js/modules/es.function.name");

exports.__esModule = true;
exports.default = optimal;

var _endsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/ends-with"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));

var _Builder = _interopRequireDefault(require("./Builder"));

var _isObject = _interopRequireDefault(require("./isObject"));

var _typeOf = _interopRequireDefault(require("./typeOf"));

function buildAndCheck(blueprint, struct, options, parentPath) {
  var _context;

  if (options === void 0) {
    options = {};
  }

  if (parentPath === void 0) {
    parentPath = '';
  }

  var unknownFields = (0, _assign.default)({}, struct);
  var builtStruct = {};
  (0, _forEach.default)(_context = (0, _keys.default)(blueprint)).call(_context, function (baseKey) {
    var _context2;

    var key = baseKey;
    var value = struct[key];
    var builder = blueprint[key];
    var path = String(parentPath ? parentPath + "." + key : key);

    if (builder instanceof _Builder.default || (0, _isObject.default)(builder) && (0, _endsWith.default)(_context2 = builder.constructor.name).call(_context2, 'Builder')) {
      builtStruct[key] = builder.runChecks(path, value, struct, options);
    } else if ("production" !== process.env.NODE_ENV) {
      throw new Error("Unknown blueprint for \"" + path + "\". Must be a builder.");
    }

    delete unknownFields[key];
  });

  if (options.unknown) {
    (0, _assign.default)(builtStruct, unknownFields);
  } else if ("production" !== process.env.NODE_ENV) {
    var unknownKeys = (0, _keys.default)(unknownFields);

    if (unknownKeys.length > 0) {
      throw new Error("Unknown fields: " + unknownKeys.join(', ') + ".");
    }
  }

  return builtStruct;
}

function optimal(struct, blueprint, options) {
  if (options === void 0) {
    options = {};
  }

  if ("production" !== process.env.NODE_ENV) {
    if (!(0, _isObject.default)(struct)) {
      throw new TypeError("Optimal requires a plain object, found " + (0, _typeOf.default)(struct) + ".");
    } else if (!(0, _isObject.default)(options)) {
      throw new TypeError('Optimal options must be a plain object.');
    } else if (!(0, _isObject.default)(blueprint)) {
      throw new TypeError('A blueprint is required.');
    }
  }

  return buildAndCheck(blueprint, struct, options);
}