"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = typeOf;

var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _isObject = _interopRequireDefault(require("./isObject"));

function typeOf(value) {
  if ((0, _isArray.default)(value)) {
    return (0, _every.default)(value).call(value, function (item) {
      return typeof item === typeof value[0];
    }) ? 'array' : 'union';
  }

  if ((0, _isObject.default)(value)) {
    return value.constructor === Object ? 'object' : 'instance';
  }

  switch (typeof value) {
    case 'boolean':
    case 'function':
    case 'number':
    case 'string':
      return typeof value;

    default:
      return 'unknown';
  }
}